<?php

require_once "fs_lang.php";
require_once "common_functions.php";
require_once 'generate_common.php';

$wait_before_redirect = 3;
$text_title = get_var('chgpwd_form');

// First session variable, second post variable
if ( isset($_SESSION['session_username']) && $_SESSION['session_username'] != '')
	$username = $_SESSION['session_username'];
else
	$username = $_POST['username'];

$old_password = $_POST['old_password'];
$new_password1 = $_POST['new_password1'];
$new_password2 = $_POST['new_password2'];
$success_url = $_POST['success_url'];
$failed_url = $_POST['failed_url'];
$return_result_text[0] = get_var('chgpwd_ok_header');
$return_result_text[1] = get_var('chgpwd_problem_id_empty');
$return_result_text[2] = get_var('chgpwd_problem_old_pwd_empty');
$return_result_text[3] = get_var('chgpwd_problem_new_pwd_empty');  
$return_result_text[4] = get_var('chgpwd_problem_pwd_mismatch'); 
$return_result_text[5] = get_var('chgpwd_problem_id_not_exists');
$return_result_text[6] = get_var('chgpwd_problem_old_pwd_mismatch');
$return_result_text[7] = get_var('chgpwd_problem_access_right');
$error_message_header = get_var('chgpwd_fail_header');
$error_message_footer = get_var('chgpwd_fail_link');
$success_message_footer = get_var('chgpwd_ok_link');

$settingobj = new COM("FSCONFIG.Cfgmgr") or die("fs_chgpwd.php FSCONFIG.Cfgmgr Object cannot be created!");
$enable_chgpwd = $settingobj->getKey("enable_chgpwd", "misc");

$status_message = "
	<span class=\"failloginspan\">".$error_message_header."</span><br><br>";

if ($username == "") {
    $status_message .= "
	<span class=\"textspan\">".$return_result_text[1]."</span><br>
	<a class=\"freelink\" href=\"".$failed_url."\">".$error_message_footer."</a><br>";
    $error_no = 1;
} elseif ($old_password == "") {
    $status_message .= "
	<span class=\"textspan\">".$return_result_text[2]."</span><br>
	<a class=\"freelink\" href=\"".$failed_url."\">".$error_message_footer."</a><br>";
    $error_no = 2;
} elseif ($new_password1 == "") {
    $status_message .= "
	<span class=\"textspan\">".$return_result_text[3]."</span><br>
	<a class=\"freelink\" href=\"".$failed_url."\">".$error_message_footer."</a><br>";
    $error_no = 3;
} elseif (strcmp($new_password1, $new_password2) != 0) {
    $status_message .= "
	<span class=\"textspan\">".$return_result_text[4]."</span><br>
	<a class=\"freelink\" href=\"".$failed_url."\">".$error_message_footer."</a><br>";
    $error_no = 4;
} elseif ($enable_chgpwd == "0") {
    $status_message .= "
	<span class=\"textspan\">".$return_result_text[7]."</span><br>
	<a class=\"freelink\" href=\"".$failed_url."\">".$error_message_footer."</a><br>";
    $error_no = 7;
} else {
    $q = "SELECT * FROM ".fs_usr_table()." WHERE NAME = '".$username."';";
    $result = db_query($q);

    $count = 0;

    while(odbc_fetch_row($result)) {
         $count = $count + 1;
    }

    if ($count > 0) {
	$error_no = 0;

	$pwd_offload = $settingobj->getKey("pwd_offload", "gateway");

	if ($pwd_offload == "on" || $pwd_offload == "ON") {
	    $encrypt_path = $settingobj->getKey("encrypt_path", "gateway");
	} else {
	    $fs_path = $settingobj->getFsPath(); 
            $encrypt_path = $fs_path."dispatcher\\encrypt_pwd.exe";
	}
        $cmd = "\"".$encrypt_path."\" ".$old_password;
        //$old_pwd = $settingobj->runCommand($cmd);
        $sys = new sysfunc();
        $old_pwd = $sys->runCommand($cmd);
        $sys = null;
        $db_pwd = odbc_result($result, "pwd");
	if (strcmp($old_pwd, $db_pwd) == 0) {
	    $status_message = "
	<span class=\"textspan\">".$return_result_text[0]."</span><br>
	<a class=\"freelink\" href=\"".$success_url."\">".$success_message_footer."</a><br>";
	    $submit_url = $success_url;

	    $cmd = "\"".$encrypt_path."\" ".$new_password1;
	    //$new_pwd = $settingobj->runCommand($cmd);
	    $sys = new sysfunc();
	    $new_pwd = $sys->runCommand($cmd);
	    $sys = null;
	    $q2 = "UPDATE ".fs_usr_table()." SET PWD = '".$new_pwd."' WHERE NAME = '".$username."';";
	    $result2 = db_query($q2);
	} else {
	    $status_message .= "
	<span class=\"textspan\">".$return_result_text[6]."</span><br>
	<a class=\"freelink\" href=\"".$failed_url."\">".$error_message_footer."</a><br>";
	    $error_no = 6;
	}
    } else {
	$status_message .= "
	<span class=\"textspan\">".$return_result_text[5]."</span><br>
	<a class=\"freelink\" href=\"".$failed_url."\">".$error_message_footer."</a><br>";
	$error_no = 5;
    }
}
if ($error_no == 0) {
    $submit_url = $success_url;
} else {
    $submit_url = $failed_url;
}

$form_element = "error_code";
$element_value = $error_no;
//$settingobj->Release();
$settingobj = null;

// 20080408 - Collect dynamic HTML content for layout
$smarty = new SmartyConnect;
$metaStr = '';
if ($error_no == 1 || $error_no == 2 || $error_no == 3 || $error_no == 4 || $error_no == 5 || $error_no == 6 || $error_no == 7) { //goes back 2 the previous page
    $metaStr = "<meta http-equiv=\"refresh\" content=\"$wait_before_redirect;url=$submit_url\">";
} else {
    $metaStr = metaCharset();
}
$smarty->assign('L_FSCHGPWD_META', $metaStr);
$smarty->assign('L_FSCHGPWD_TITLE', $text_title);
$smarty->assign('FSCHGPWD_SUBMIT_URL', $submit_url);
$smarty->assign('FSCHGPWD_FORM_ELEMENT', $form_element);
$smarty->assign('FSCHGPWD_ELEMENT_VALUE', $element_value);
$smarty->assign('L_FSCHGPWD_STATUS', $status_message);
$smarty->assign('J_COMMON', $j_common);

// 20080408 - Move layout content and include the file here
$smarty->display('fs_chgpwd_body.tpl');

?>
