<?php
// no cache for browser
header('Cache-Control: no-cache, must-revalidate');
// include functions
require_once 'common_functions.php';
require_once 'fs_lang.php';

// $wait_b4_to_ok_page='0';
$wait_b4_to_fail_page='3';
$wait_b4_to_zero_page='5';

// 20080502 - Add retrieving Self Sign-up display flag
// 20080417 - Add retrieving scratch mode
$settingobj = new COM('FSCONFIG.Cfgmgr') or die('fs_login.php FSCONFIG.Cfgmgr Object cannot be created!');
$redirect_address = $settingobj->getKey( 'redirect_address', 'gateway');
$dsn_file = $settingobj->getKey( 'Datasource', 'gateway');
$scratchLogin = $settingobj->getKey('scratch_login', 'gateway');
$displaySelfSignup = $settingobj->getKey('display_self_sign_up', 'gateway');
$dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');
$dsn = '';

if (!feof($dsn_source)) {
    $line=fgets($dsn_source,512);
}
while (!feof($dsn_source)) {
    $line=fgets($dsn_source,512);
    if (trim($line)!='') $dsn=$dsn.$line;
}
$dsn=str_replace("\r\n",';',$dsn);

$isRedirect = $settingobj->getKey( 'redirect_cart', 'gateway');

// client pass-through  by 0 = MAC-based 1 = IP-based
$session_handling = $settingobj->getKey( 'session_handling', 'gateway');

// get verion
$version = $settingobj->getKey('version', 'version');

// get the absolute path and infobox port
$urlhead=fs_urlhead("infobox");

// 20090918 - Add retrieving login page content display control
$disable_show_reminder = $settingobj->getKey('disable_show_reminder', 'lang');
$disable_show_example = $settingobj->getKey('disable_show_example', 'lang');
$disable_show_link = $settingobj->getKey('disable_show_link', 'lang');
$disable_show_tc = $settingobj->getKey('disable_show_tc', 'lang');

//$settingobj->Release();
$settingobj=null;

// assume it is valid
$valid=true;

// 20080714 - Retrieve destination string after auto refresh
if (!isset($desturl) && isset($_SESSION['sess_desturl'])) {
    $desturl = 'desturl='.$_SESSION['sess_desturl'];
}

// now, form is submitted and desturl is not posted
if(isset($desturl)) {
    // COM object provides desturl when user login

    // 'desturl' is empty
    if($desturl=='') {
        // invalid case
        $valid = false;
    } else {    // continue processing..
	// 20090129 - Apply URL-encoded format according to RFC 1738 to the redirect links
	// 20080714 - Add else branch to get back information after auto refresh
	if (count($_GET) > 0) {
	    // in case there are others non-firstspot specific querystring, concat them..
	    // for security reason, POST data will not concat
	    foreach($_GET as $item=>$value) {
		//echo "$item: $value<br/>";
		// 20080707 - Prepare extra redirect information at the 2nd round fs_login
		if ($item == 'desturl') {
		    if (strpos($value, '&sslredir=') != FALSE) {
			$sslRedir = rawurlencode(substr($value, strpos($value, '&sslredir=')+10));
		    } elseif (strpos($value, '&loginPage=') != FALSE) {
			$loginPage = substr($value, strpos($value, '&loginPage=')+11);
		    }
		}
		// concat if value posted is neither 'desturl' nor 'patronsoft1' nor 'patronsoft2' nor 'firstspotL'
		if($item!='desturl' && $item!='patronsoft1' && $item!='patronsoft2' && $item!='firstspotL')
		    $desturl = $desturl.'&'.$item.'='.$value;
	    }
	} else {
	    if (strpos($desturl, '&sslredir=') != FALSE) {
		$sslRedir = rawurlencode(substr($desturl, strpos($desturl, '&sslredir=')+10));
	    } elseif (strpos($desturl, '&loginPage=') != FALSE) {
		$loginPage = substr($desturl, strpos($desturl, '&loginPage=')+11);
	    }
	}
    }
    // reigster desturl session, if needed
    if(!isset($_SESSION['sess_desturl']))
        $_SESSION['sess_desturl']=$desturl;

    $sess_desturl=$_SESSION['sess_desturl'];
}

if(isset($sslpage)) {
        foreach($_GET as $item=>$value) {
            if($item!='sslpage' && $item!='loginPage' && $item!='desturl' && $item!='patronsoft1' && $item!='patronsoft2' && $item!='firstspotL')
                $sslpage .= '&'.$item.'='.$value;
        }
    // 20080707
    unset($loginPage);
}

if(isset($patronsoft1)) {
    // empty ip
    if($patronsoft1=='')
        $valid=false;

    // assign session value
    if(!isset($_SESSION['sess_patronsoft1']))
        $_SESSION['sess_patronsoft1']=$patronsoft1;

    $sess_patronsoft1=$_SESSION['sess_patronsoft1'];
}

if(isset($patronsoft2)) {
    // empty ip
    if($patronsoft2=='')
        $valid=false;

    // assign session value
    if(!isset($_SESSION['sess_patronsoft2']))
        $_SESSION['sess_patronsoft2']=$patronsoft2;

    $sess_patronsoft2=$_SESSION['sess_patronsoft2'];
}

if(!isset($_SESSION['sess_desturl']) && !isset($sess_patronsoft1) && !isset($sess_patronsoft2)) {
    //echo "<script type=\"text/javascript\">location.href='".$redirect_address."';</script>";
    // 20080703 - Add extra information in redirect link at the 1st round entering fs_login
    if (isset($sslpage)) {
	$redirect_suffix = "?&sslredir=$sslpage";
    } else {
	$redirect_suffix = "?&loginPage=1";
    }
    header("Location: $redirect_address$redirect_suffix");
    exit;
} elseif (isset($sslpage)) {
    // 20080707 - New case for HTTPS request at the 1st round entering fs_login and already have session values
    header("Location: $redirect_address?&sslredir=$sslpage");
    exit;
} elseif ((!isset($ok_url) && !isset($desturl)) || !isset($_SESSION['sess_desturl']) || !isset($sess_patronsoft1) || !isset($sess_patronsoft2)) {
    // 20080707 - New case for direct accessing 5788 at the 1st round entering fs_login and already have several session values
    header("Location: $redirect_address?&loginPage=1");
    exit;
} else {
    // no cache for browser
    header('Cache-Control: no-cache, must-revalidate');
}

// check if valid
if($valid) {
    $settingobj = new COM('FSCONFIG.Cfgmgr') or die('fs_login.php FSCONFIG.Cfgmgr Object cannot be created!');

    if(isset($sess_patronsoft2)) {
        $IP_str=long2ip($sess_patronsoft2);  
        $tok = explode('.', $IP_str);
        $IP=$tok[3].'.'.$tok[2].'.'.$tok[1].'.'.$tok[0];

        $num=$settingobj->getKey( 'num_return_path', 'MNS');

	// 20080416 - Bug fix for getKey, store redirect template file to new variable for login_form use
	for ($x = 0; $x < $num; $x++) {
	    $path = $settingobj->getKey('return_path'.$x, 'MNS');
	    $net = explode(' ', $path);
	    if (isInSubnet($net[0], $net[1], $IP)) {
		$enableRedir = $settingobj->getKey('Login_enable'.$x, 'loginPhp');
		if ($enableRedir == 1) {
		    $fail_url = fs_form_to_load();
		    $redirTpl = $settingobj->getKey('Login_php_Num'.$x, "loginPhp");
		}
	    }
	}
    }
    // validate anonymous login
    if(fs_is_anonymous_mode()) {
        $fieldEmpty = false;
        $isUpdated = false;
        $arr = array('01', '02', '03', '04', '05', '06', '07', '08', '09', '10' );

        foreach ($arr as $value)
            ${"extra".$value."_not_empty"} = $settingobj->getKey( "extra$value", 'lang');

        foreach ($arr as $key => $value) {
            if( isset(${"extra$value"}) ) {
                if( ${"extra$value"}=='' && (${"extra".$value."_not_empty"} == 'on') )
                    $fieldEmpty = true;
                else
                    $isUpdated = true;
            }
        }

        if ($fieldEmpty==true) {
            $input = '<span class="failloginspan">'.get_var('extra_field_err_empty').'</span><br>';
            $meta = '<META HTTP-EQUIV="Refresh" CONTENT="'.$wait_b4_to_fail_page.';URL='.$fail_url.'?reason=invalid">'; 
            GenTable($meta, $input, '');
        }
    } else {
        //$username = get_var('user_name') . " : ";
    }

    // release the COM object
    //$settingobj->Release();

    if( !(isset($fieldEmpty)&&($fieldEmpty==true))) {
        // create COM Object
		$settingobj = new COM('FSCONFIG.Cfgmgr') or die('fs_login.php FSCONFIG.Cfgmgr Object cannot be created!');
		$IsRandom=$settingobj->getKey( 'random', 'gateway');
        if ($IsRandom) {
			$count=$settingobj->getKey( 'loginpage_pic_count', 'gateway');
			$r_no=gen_random_no($count);
		}
		else
			$r_no=0;
		$fname_loginpage_pic="loginpage_pic";
		$fname_loginpage_pic.=$r_no;
		$fname_loginpage_pic_html="loginpage_pic_html";
		$fname_loginpage_pic_html.=$r_no;
		$pic=get_pic($fname_loginpage_pic);
		$html=get_html($fname_loginpage_pic_html);
		$pic='./loginpage_pic/'.$pic;
        $login_msg = '';

        // check username
        if((isset($username) && $username!='') || isset($secret_code) || isset($anonymous_mode_button)) {
            // create COM Object
            $myobj = new COM('FSAUTH.Authserv') or die('fs_login.php FSAUTH.Authserv Object cannot be created!');

            $secret_enable=$settingobj->getKey( 'secret_enable', 'gateway');
            $firstspotusertable=$settingobj->getKey( 'Datasource_Tablename', 'gateway'); 

            if(fs_is_anonymous_mode()) {
                $username = '';
                $password = '';
                $arr = array('01', '02', '03', '04', '05', '06', '07', '09', '10' );

                if( isset($isUpdated)&&($isUpdated==true)) {
                    // connect to database
                    $dsn_file = $settingobj->getKey( 'Datasource', 'gateway');
                    $dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');  
                    $dsn='';

                    if(!feof($dsn_source)) 
                        $line=fgets($dsn_source,512); 

                    while(!feof($dsn_source)) {
                        $line=fgets($dsn_source,512);
                        if (trim($line)!='') $dsn=$dsn.$line;
                    }

                    $dsn=str_replace("\r\n",';',$dsn);
                    $userDB=odbc_connect($dsn,'','');

                    // update the exfield table with extra information field
                    $q = 'insert into '.fs_exfield_table().' ( signuptime, aexmac, ';
                    $v = ' values( '.mktime().', '.$sess_patronsoft2.', ';

                    foreach ($arr as $value) {
                        if (isset(${"extra$value"})) {
                            $q .= "AEX$value, ";
                            $v .= "'".${"extra$value"}."', ";
                        }
                    }

                    $q = substr($q, 0, strlen($q) - 2);  //trim the ending comma
                    $v = substr($v, 0, strlen($v) - 2);  //trim the ending comma

                    $q .= ") ";
                    $v .= ");";
                    $q .= $v;
                    $result = odbc_exec($userDB,$q); 
                }
            }
            
	    // 20071031 - Check DB for extra information before authentication
            $obj = new COM("FSCONFIG.Cfgmgr") or die("fs_login.php FSCONFIG.Cfgmgr Object cannot be created!");
            $isRADIUS = $obj->getKey("use_radius", "radius");
            //$obj->Release();
            $obj=null;
	    if ($isRADIUS != "true") {
		// connect to database
		$dsn_file = $settingobj->getKey( 'Datasource', 'gateway');
		$dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');  
		$dsn='';

		if(!feof($dsn_source)) 
		    $line=fgets($dsn_source,512); 

		while(!feof($dsn_source)) {
		    $line=fgets($dsn_source,512);
		    if (trim($line)!='') $dsn.=$line;
		}

			// 20090326 - Suppress SQL error shown in client browser
			$dsn=str_replace("\r\n",';',$dsn);
			$er = error_reporting(0);
			$userDB=odbc_connect($dsn,'','');
			error_reporting($er);

			// 20090326 - Improve error handling
			$result = FALSE;
			$q = 'select count(*) as num from '.fs_usr_table()." where ReqSignUp = 'Y' and name = '$username';";
			if ($userDB != 0) {
				$result = odbc_exec( $userDB, $q );
				if ($result != FALSE) {
					$RequestSU = odbc_result( $result, 'num' );
					if( $RequestSU>0 ){
						if(!session_id())
						session_start();

						$_SESSION['session_username']=$username;

						// 20090812 - Set password as blank for scratch mode
						// 20071102 - Check password and stop redirect if incorrect
						if ($scratchLogin == 'on') {
							$password = '';
						}
						$_SESSION['session_password'] = $password;
						$pwValidNum = fs_is_password_correct($username, $password);
						if ($pwValidNum > 0) {
						header('Location: ReqSignUp_Form.php');
						exit;
						}
					}
				}
			}

			if ($userDB == 0 || $result == FALSE) {
				$input = '<span class="failloginspan">'.get_var('login_database_unavailable').'</span><br>';
				$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=".$fail_url."?reason=invalid&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
				GenTable($meta, $input, '');
			}
	    }

            // get clinet browser information
            $useragent = $_SERVER['HTTP_USER_AGENT'];
            
            if(isset($logout))
                    $objrsult = $myobj->ForceLogout($username);
           else if (isset($logout_from_other))
                    $objrsult = $myobj->ForceLogoutFromOtherSite($username, $sess_patronsoft2); // * In Anonymous and Share Secret, username will no usage

            if (strtolower($secret_enable)=='on') {
                $objrsult = $myobj->Authenticate('', $secret_code, $sess_patronsoft1, $sess_patronsoft2, $useragent);
            } else {         

		// 20080417 - Set password as blank for scratch mode
		if ($scratchLogin == 'on') {
		    $password = '';
		}

                $objrsult = $myobj->Authenticate($username, $password, $sess_patronsoft1, $sess_patronsoft2, $useragent);

            }

            // authenticated
            
	    // 20080410 - Return string instead of echo
            //close popup
	    $scriptInput = '';
	    if (!($objrsult=='TR_MODE' || $objrsult=='SUCCESS' || $objrsult=='INSERT_TABLE' || $objrsult=='ALREADY_SERVING')) {
		$scriptInput .= "
	popupWin = window.open('', 'firstspotInfoBox', '');
	if (popupWin) {
	    popupWin.close();
	}";
	    }
           	
           	//authentication mode
            if($objrsult=='TR_MODE') {
		// 20080709 - Add okurl
                // In firstspot trial version, users will be automatically redirected to the page "Redirect.php" 
                // during the following object call, while no redirection will happen for release version.
                header("Location: trialmode.dll?login=$username&patronsoft1=$sess_patronsoft1&patronsoft2=$sess_patronsoft2&browserInfo=$useragent&okurl=$ok_url");
                exit;
            } else if($objrsult=='SUCCESS' || $objrsult=='INSERT_TABLE') {
                if(!session_id())
                    session_start();

                if (isset($_SESSION['session_username']))
                    $_SESSION['session_username']='';

                // The following code has no effect in trial version, but will cause a redirection to the 
                // page 'Redirect.php' in release version.
                header("Location: $ok_url");
                exit;
            } else if($objrsult=='ALREADY_SERVING') {
                // current user and machine has already logged in and internet connection has been made ready, 
                // no need to submit login information again
                header("Location: $ok_url");
                exit;
            } else if($objrsult=='ALREADY_LOGGED') {
		$settingobj = new COM('FSCONFIG.Cfgmgr') or die('redirect.php FSCONFIG.Cfgmgr Object cannot be created!');
		$showinfo = $settingobj->getKey('show_infobox', 'gateway');
		$start_up_redirect_option = $settingobj->getKey("start_up_redirect_option", "gateway");
		//20080827	added redirect to info box option 
		if ($start_up_redirect_option == 2){//redirect to info box instead of pop-up
			$showinfo="off";
		}
		$settingobj = null;
    	//20080829	make infobox resizabe		
		// 20080410 - Return string instead of echo
		if (strtolower($showinfo) == "on") {
		    $scriptInput .= "
	var y = window.screen.availHeight - 25;
	var x = window.screen.availWidth - 10;
	var w = 400;
	var h = 200;
	y -= h;
	x -= w;

	function popInfoBox()
	{
		if (test){
		    popupWin = window.open('', 'firstspotInfoBox', 'toolbar=no,menubar=no,scrollbars=no,resizable=yes,top=' + y + ', left=' + x + ', height=' + h + ', width=' + w);
		    if (popupWin) {
			popupWin.location='".$urlhead."info.php?state=wait';
			popupWin.focus();
		    }
		}
	}";
		}
	
                $input = '
		    <br><span class="failloginspan">'.get_var('logged').'</span><br><br>
		    <form class="failloginspan" name="forcelogout" action="fs_login.php" method="post">
			<input type="hidden" name="username" value="'.$username.'">
			<input type="hidden" name="password" value="'.$password.'">
			<input type="hidden" name="sess_patronsoft1" value="'.$sess_patronsoft1.'">
			<input type="hidden" name="sess_patronsoft2" value="'.$sess_patronsoft2.'">
			<input type="hidden" name="ok_url" value="redirect.php">
			<input type="hidden" name="fail_url" value="login_form.php">
			<input type="hidden" name="zero_url" value="cart.php">
			<input type="hidden" name="cart_url" value="cart.php">
			<input type="hidden" name="logout" value="true">
			<input type="submit" class="normalbtn" name="btn_relogin" value="Click here to re-login" onclick="popInfoBox()">
		    </form>';
                GenTable('', $input, $scriptInput);
            } else if($objrsult=='ZERO_TIMELEFT') {
                if(!session_id())
                    session_start();

                $_SESSION['session_username']=$username;

                $meta='';
                $input = '<span class="failloginspan">'.get_var('no_usage').'</span><br>';
                
                if($isRedirect==1){
                    $temp_url = $cart_url;
                    $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=nousage'>";
                    if ($isRADIUS == "true") {
                        $temp_url = $fail_url;
			// 20080714 - Save destination string
			$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=nousage&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
		    }
                }
                GenTable($meta, $input, $scriptInput);
            } else if($objrsult=='BWFAIL') {
                if(!session_id())
                    session_start();

                $_SESSION['session_username']=$username;

                $meta = '';
                $input = '<span class="failloginspan">'.get_var('data_transfer_0').'</span><br>';
                 if($isRedirect==1){
                    $temp_url = $cart_url;
                    $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfail'>";
                    if ($isRADIUS == "true") {
                        $temp_url = $fail_url;
			// 20080714 - Save destination string
			$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfail&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
		    }
                }
                GenTable($meta, $input, $scriptInput);
            } else if($objrsult=='BWFAILUL') {
                if(!session_id())
                    session_start();

                $_SESSION['session_username']=$username;

                $meta = '';
                $input = '<span class="failloginspan">'.get_var('data_transfer_1').'</span><br>';
                if($isRedirect==1){
                    $temp_url = $cart_url;
                    $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfailul'>";
                    if ($isRADIUS == "true") {
                        $temp_url = $fail_url;
			// 20080714 - Save destination string
			$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfailul&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
		    }
                }
                GenTable($meta, $input, $scriptInput);
	    // 20071126 - Add case for bandwidth quota sharing
	    } else if ($objrsult == 'BWFAILSHARE') {
                if (!session_id()) {
		    session_start();
		}
                $_SESSION['session_username'] = $username;
                $meta = '';
                $input = '<span class="failloginspan">'.get_var('data_transfer_2').'</span><br>';
                if ($isRedirect == 1) {
                    $temp_url = $cart_url;
                    $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfailshare'>";
                    if ($isRADIUS == "true") {
                        $temp_url = $fail_url;
			// 20080714 - Save destination string
			$meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$temp_url."?reason=bwfailshare&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
		    }
                }
                GenTable($meta, $input, $scriptInput);
            } else if($objrsult=='ACC_DISABLED') {
                if(!session_id())
                    session_start();
                $_SESSION['session_username']=$username;
		$meta='';
                $input = '<span class="failloginspan">'.get_var('acc_disabled').'</span><br>';
                if($isRedirect==1)
                    $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$cart_url."?reason=disabled'>";   
                GenTable($meta, $input, $scriptInput);
            } else if($objrsult=='START_DATE') {
                if(!session_id())
                    session_start();

                $_SESSION['session_username']=$username;

                $meta = '';
                $input = '<span class="failloginspan">'. get_var('start_date').'</span><br>';
                if($isRedirect==1)
                    $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=".$cart_url."?reason=sdate'>";
                GenTable($meta, $input, $scriptInput);             
            } else if($objrsult=='MAX_LOGINS') {
                if(!session_id())
                    session_start();

                $_SESSION['session_username']=$username;

                $meta = '';
                $input = '<span class="failloginspan">'.get_var('max_logins').'</span><br>';
                if($isRedirect==1)
                    $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=" .  $cart_url . "?reason=maxlogins'>";          
                GenTable($meta, $input, $scriptInput);  
            } else if($objrsult=='EXPIRY_DATE') {
                if(!session_id())
                    session_start();

                $_SESSION['session_username']=$username;

                $meta = '';
                $input = '<span class="failloginspan">'.get_var('expiry_date').'</span><br>';
                if($isRedirect==1)
                    $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_zero_page.";URL=" .  $cart_url . "?reason=edate'>";
                GenTable($meta, $input, $scriptInput);                   
            } else if($objrsult=='SECRET_ERROR') {
                $input = '<span class="failloginspan">wrong code! Please try again...</span><br>';
		// 20080714 - Save destination string
                $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=".$fail_url."?reason=invalid&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
                GenTable($meta, $input, $scriptInput);
            } else if($objrsult=='REACH_CONC_MAX') {
                $input = '<span class="failloginspan">'.get_var('login_max_conc').'</span><br>';
                GenTable('', $input, $scriptInput);
            } else if($objrsult=='MAC_MISMATCH') {
	            	$input = '<span class="failloginspan">'.get_var('mac_mismatch').'</span><br>';
                GenTable('', $input, $scriptInput);       
            } else if($objrsult=='LOGGED_IN_OTHER_SITE' ) {
	            $settingobj = new COM('FSCONFIG.Cfgmgr') or die('redirect.php FSCONFIG.Cfgmgr Object cannot be created!');
    			$showinfo = $settingobj->getKey('show_infobox', 'gateway');
				$start_up_redirect_option = $settingobj->getKey("start_up_redirect_option", "gateway");
				//20080827	added redirect to info box option 
				if ($start_up_redirect_option == 2){//redirect to info box instead of pop-up
					$showinfo="off";
				}
    			$settingobj = null;
    			//20080829	make infobox resizabe
				if (strtolower($showinfo) == "on" && !fs_is_anonymous_mode()) {
				    $scriptInput .= "
			var y = window.screen.availHeight - 25;
			var x = window.screen.availWidth - 10;
			var w = 400;
			var h = 200;
			y -= h;
			x -= w;
		
			function popInfoBox()
			{
				if (test){
				    popupWin = window.open('', 'firstspotInfoBox', 'toolbar=no,menubar=no,scrollbars=no,resizable=yes,top=' + y + ', left=' + x + ', height=' + h + ', width=' + w);
				    if (popupWin) {
					popupWin.location='".$urlhead."info.php?state=wait';
					popupWin.focus();
				    }
			    }
			}";
				}
				if (fs_is_anonymous_mode()){
					if (fs_is_shared_secret_in_anonymous_mode()){
						$input =  '
			    <br><span class="failloginspan">'.get_var('logged_in_other_fs').'</span><br><br>
			    <form class="failloginspan" name="forcelogout" action="fs_login.php" method="post">
			        <input type="hidden" name="sess_patronsoft1" value="'.$sess_patronsoft1.'">
			        <input type="hidden" name="sess_patronsoft2" value="'.$sess_patronsoft2.'">
			        <input type="hidden" name="ok_url" value="redirect.php">
			        <input type="hidden" name="fail_url" value="alogin_form.php">
			        <input type="hidden" name="cart_url" value="alogin_form.php">
			        <input type="hidden" name="anonymous_mode_button" value="true">
			    	<input type="hidden" name="secret_code" value="'.$secret_code.'">
			        <input type="hidden" name="logout_from_other" value="true">
			        <input type="submit" class="normalbtn" name="btn_relogin" value="'.get_var('fail_force_logout_from_other_fs_button').'" onclick="popInfoBox()">
			    </form>';
					}else {
						$input =  '
				    <br><span class="failloginspan">'.get_var('logged_in_other_fs').'</span><br><br>
				    <form class="failloginspan" name="forcelogout" action="fs_login.php" method="post">
				        <input type="hidden" name="sess_patronsoft1" value="'.$sess_patronsoft1.'">
				        <input type="hidden" name="sess_patronsoft2" value="'.$sess_patronsoft2.'">
				        <input type="hidden" name="ok_url" value="redirect.php">
				        <input type="hidden" name="fail_url" value="alogin_form.php">
				        <input type="hidden" name="cart_url" value="alogin_form.php">
				        <input type="hidden" name="anonymous_mode_button" value="true">
				        <input type="hidden" name="logout_from_other" value="true">
				        <input type="submit" class="normalbtn" name="btn_relogin" value="'.get_var('fail_force_logout_from_other_fs_button').'" onclick="popInfoBox()">
				    </form>';
				    }
				}else{
	                $input =  '
			    <br><span class="failloginspan">'.get_var('logged_in_other_fs').'</span><br><br>
			    <form class="failloginspan" name="forcelogout" action="fs_login.php" method="post">
			        <input type="hidden" name="username" value="'.$username.'">
			        <input type="hidden" name="password" value="'.$password.'">
			        <input type="hidden" name="sess_patronsoft1" value="'.$sess_patronsoft1.'">
			        <input type="hidden" name="sess_patronsoft2" value="'.$sess_patronsoft2.'">
			        <input type="hidden" name="ok_url" value="redirect.php">
			        <input type="hidden" name="fail_url" value="login_form.php">
			        <input type="hidden" name="zero_url" value="cart.php">
			        <input type="hidden" name="cart_url" value="cart.php">
			        <input type="hidden" name="logout_from_other" value="true">
			        <input type="submit" class="normalbtn" name="btn_relogin" value="'.get_var('fail_force_logout_from_other_fs_button').'" onclick="popInfoBox()">
			    </form>';
					
				}
                GenTable('', $input, $scriptInput);
            } else {
                $input='<span class="failloginspan">'.get_var('invalid').'</span><br>';
		// 20080714 - Save destination string
                $meta = "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=".$fail_url."?reason=invalid&desturl=".urlencode($_SESSION['sess_desturl'])."'>";
                GenTable($meta, $input, $scriptInput);
            }

            // free the COM object
            //$myObj->Release();
            $myobj=null;  
        } elseif (isset($username) && $username=='') {
            $input= '<span class="failloginspan">'.get_var('invalid').'</span><br>';
	    // 20080714 - Save destination string
            $meta= "<META HTTP-EQUIV='Refresh' CONTENT='".$wait_b4_to_fail_page.";URL=".$fail_url."?reason=invalid&desturl=".urlencode($_SESSION['sess_desturl'])."'>"; 
            GenTable($meta, $input, '');         
        }

        //release COM object
        //$settingobj->Release();
        $settingobj=null;
    } // end fieldEmpty
} else {  // login invalid
    if (!isset($fail_url)) $fail_url='login_select.php';
    $input= '<span class="failloginspan">'.get_var('invalid_access').'</span><br>';
    // 20080714 - Save destination string
    $meta= '<META HTTP-EQUIV="Refresh" CONTENT="'.$wait_b4_to_fail_page.';URL='.$fail_url.'?desturl='.urlencode($_SESSION['sess_desturl']).'">';
    GenTable($meta, $input, '');
}

$obj = new COM('FSCONFIG.Cfgmgr') or die('fs_login.php FSCONFIG.Cfgmgr Object cannot be created!');
$value=$obj->getKey('show_infobox', 'gateway');
$start_up_redirect_option = $obj->getKey("start_up_redirect_option", "gateway");
//20080827	added redirect to info box option 
if ($start_up_redirect_option == 2){//redirect to info box instead of pop-up
	$value="off";
}
$obj=null;

// check RADIUS mode
$obj = new COM("FSCONFIG.Cfgmgr") or die("fs_login.php FSCONFIG.Cfgmgr Object cannot be created!");
$isRADIUS = $obj->getKey("use_radius", "radius");
$global_bwcount_dl = $obj->getKey("bwcount_dl", "DataTransfer");
$global_bwquota_dl = $obj->getKey("bwquota_dl", "DataTransfer");
$global_bwcount_ul = $obj->getKey("bwcount_ul", "DataTransfer");
$global_bwquota_ul = $obj->getKey("bwquota_ul", "DataTransfer");
//$obj->Release();
$obj=null;

if ( ((isset($sess_patronsoft2) && $sess_patronsoft2!="" && $session_handling == 0) || (isset($sess_patronsoft1) && $sess_patronsoft1 !="" && $session_handling == 1)) && 
		!fs_is_anonymous_mode() && $isRADIUS == "false") {
		
	if ($session_handling==0){
		// Auto fill the username when the MAC address is the username
		$macname = make_mac_name($sess_patronsoft2);
		$q = "SELECT count(*) as num FROM ".fs_usr_table()." WHERE MACasUsr='Y' and name='".$macname."'";
		$result = db_query($q);

		// 20090326 - Improve error handling
		if ($result == FALSE) {
		    $num = 0;
		} else {
		    $num = odbc_result($result, "num");
		    $s_name = $macname;
		}
	}else{
		// Auto fill the username when the IP address is the username
		$ipname = make_ip_name($sess_patronsoft1);
		$q = "SELECT count(*) as num FROM ".fs_usr_table()." WHERE MACasUsr='Y' and name='".$ipname."' ;";
		$result = db_query($q);

		// 20090326 - Improve error handling
		if ($result == FALSE) {
		    $num = 0;
		} else {
		    $num = odbc_result($result, "num");
		    $s_name = $ipname;
		}
	}
	
    if( $num > 0 ) {
	    $q = "SELECT pwd as pw, status, sdate, edate, bwquota, bwquotaUL, bwquotaSha, bwcount, bwcountUL, bwcountSha, accumbw, accumbwUL, accumbwSha FROM ".fs_usr_table()." WHERE MACasUsr='Y' and name='".$s_name."'";
	    $result = db_query($q);
	    $pw = odbc_result($result, "pw");
		$status = odbc_result($result, "status");
		$bwquota = odbc_result($result, "bwquota");
		$bwquotaUL = odbc_result($result, "bwquotaUL");
		$bwquotaSha = odbc_result($result, "bwquotaSha");
		$bwcount = odbc_result($result, "bwcount");
		$bwcountUL = odbc_result($result, "bwcountUL");
		$bwcountSha = odbc_result($result, "bwcountSha");
		$accumbw = odbc_result($result, "accumbw");
		$accumbwUL = odbc_result($result, "accumbwUL");
		$accumbwSha = odbc_result($result, "accumbwSha");
		$sdate = odbc_result($result, "sdate");
		$edate = odbc_result($result, "edate");
		
		$currenttime = mktime();
		
		if($sdate!="") {
			list($day,$mon,$date,$time,$year)    = explode(" ", $sdate);
			list($hr,$min,$sec)  = explode(":", $time);
			$starttime = mktime($hr, $min, $sec, toNumericMonth($mon), $date, $year);
		}
		
		if($edate!="") {
			list($day,$mon,$date,$time,$year)    = explode(" ", $edate);
			list($hr,$min,$sec)  = explode(":", $time);
			$endtime = mktime($hr, $min, $sec, toNumericMonth($mon), $date, $year);
		}
		
	    // Passive Login 
	    if ($pw == ''){
		    if(!session_id())
	        	session_start();
	        	
	      $_SESSION['session_username']=$s_name;
	
	      $meta='';
		  
		  if ($status == 1){
			$input = '<span class="failloginspan">'.get_var('acc_disabled').'</span><br>';
		  }
		  else if (($bwcount == 2 && $accumbw>= $bwquota) || ($bwcount == "" && $global_bwcount_dl == 2 && $accumbw>= $global_bwquota_dl)){
			$input = '<span class="failloginspan">'.get_var('data_transfer_0').'</span><br>';
		  }
		  else if (($bwcountUL == 2 && $accumbwUL>= $bwquotaUL) || ($bwcountUL == "" && $global_bwcount_dl == 2 && $accumbwUL>= $global_bwquota_ul)){
			$input = '<span class="failloginspan">'.get_var('data_transfer_1').'</span><br>';
		  }
		  else if (($bwcountSha == 2 && $accumbwSha>= $bwquotaSha)){
			$input = '<span class="failloginspan">'.get_var('data_transfer_2').'</span><br>';
		  }
		  else if ($sdate!="" && $currenttime < $starttime){
			$input = '<span class="failloginspan">'.get_var('start_date').'</span><br>';
		  }
		  else if ($edate!="" && $currenttime >= $endtime){
			$input = '<span class="failloginspan">'.get_var('expiry_date').'</span><br>';
		  }
		  else{
			$input = '<span class="failloginspan">'.get_var('no_usage').'</span><br>';
		  }
	
	      if($isRedirect==1)
	        $meta = "<META HTTP-EQUIV='Refresh' CONTENT= '".$wait_b4_to_zero_page." ;URL= cart.php?reason=nousage'>";
	        
				GenTable($meta, $input, '');	
	    }

    // 20090326 - Handling for database failure
    } elseif ($result == FALSE) {
		$input = '<span class="failloginspan">'.get_var('login_database_unavailable').'</span><br>';
		$scriptInput = "
	popupWin = window.open('', 'firstspotInfoBox', '');
	if (popupWin) {
	    popupWin.close();
	}";
		GenTable('', $input, '');
	}
}

//20080829	make infobox resizabe
// 20080401 - Output function content
function GetFunctContent($functName)
{
    $retStr = '';

    if ($functName == 'submitPopup') {
	global $value, $urlhead;

	$retStr = "if (test) {";
	if (strcasecmp($value, "ON") == 0 ) {
	    $retStr .= "
	    var popupName = 'firstspotInfoBox';
	    popup = window.open('', popupName, 'toolbar=no,menubar=no,scrollbars=no,resizable=yes,top=' + y + ', left=' + x + ', height=' + h + ', width=' + w);
	    popup.location = '".$urlhead."info.php?state=wait';
	    popup.blur();
	    window.focus();";
	} else {
	    $retStr .= "return;";
	}
	$retStr .= "
	} else {
	    return;
	}";
    } else if ($functName == 'fillName') {
	// 20080418 - Add password handling under scratch mode
	global $isRADIUS;
	global $sess_patronsoft2, $session_handling, $num, $pw, $version, $macname;
	global $sess_patronsoft1, $ipname;
	global $scratchLogin;

	if ($isRADIUS == "true") {
	    $retStr = "document.loginForm.username.focus()";
	} else if (isset($sess_patronsoft2) && $sess_patronsoft2 != "" && $session_handling == 0) {
	    if (($num > 0) && ($pw != '') && substr_count(strtolower($version), 'standard') == 0) {
		$retStr = "document.loginForm.username.value = '$macname';
	document.loginForm.username.readOnly = true;
	document.getElementById('name').style.display = 'none';
	document.getElementById('input').style.display = 'none';";
		if ($scratchLogin == 'off') {
		    $retStr .= "
	document.loginForm.password.focus();";
		}
	    } else if (fs_is_shared_secret_in_anonymous_mode()) { // share secret
		$retStr = "if (document.loginForm.secret_code) {
	    document.loginForm.secret_code.focus();
	}";
	    }
		else if(fs_is_anonymous_mode()){ // anonymous
			$retStr .= "if (document.loginForm.anonymous_mode_button) {
				document.loginForm.anonymous_mode_button.focus();
			}";
		}
		else{ // normal user name and password
			$retStr .= "if (document.loginForm.username) {
				document.loginForm.username.focus();
			}";
		}
	} else if (isset($sess_patronsoft1) && $sess_patronsoft1 != "" && $session_handling == 1) {
	    if (($num > 0) && ($pw != '') && substr_count(strtolower($version), 'standard') == 0) {
		$retStr = "document.loginForm.username.value = '$ipname';
	document.loginForm.username.readOnly = true;
	document.getElementById('name').style.display = 'none';
	document.getElementById('input').style.display = 'none';";
		if ($scratchLogin == 'off') {
		    $retStr .= "
	document.loginForm.password.focus();";
		}
	    } else if (fs_is_shared_secret_in_anonymous_mode()) {
		$retStr = "if (document.loginForm.secret_code) {
	    document.loginForm.secret_code.focus();
	}";
	    }
		else if(fs_is_anonymous_mode()){ // anonymous
			$retStr .= "if (document.loginForm.anonymous_mode_button) {
				document.loginForm.anonymous_mode_button.focus();
			}";
		}
		else{ // normal user name and password
			$retStr .= "if (document.loginForm.username) {
				document.loginForm.username.focus();
			}";
		}
	}
    }

    return $retStr;
}

// 20080424 - Output login page text content
function GetLoginTextContent($sPathLabel, $sTag, $bHtml, $bArrayOut)
{
    $bTagFound = false;

    if ($bArrayOut) {
	$sRet = array();
    } else {
	$sRet = '';
    }

    $cfgObj = new COM('FSCONFIG.Cfgmgr') or die('fs_login.php FSCONFIG.Cfgmgr Object cannot be created!');
    $sFilePath = $cfgObj->getKey($sPathLabel, 'lang');
    $cfgObj = null;

    if (isset($sFilePath) && $sFilePath != '') {
	$fp = fopen($sFilePath, 'rt');
	if ($fp) {
	    while (!feof($fp)) {
		$buffer = fgets($fp);
		if ($buffer[0] == ';') {
		    continue;
		}
		if (!$bTagFound && strncmp($buffer, $sTag, strlen($sTag)) == 0) {
		    $bTagFound = true;
		    continue;
		}
		if ($bTagFound && strlen($buffer) >= 2 && $buffer[0] == '[' && ($buffer[strlen($buffer)-2] == ']' || $buffer[strlen($buffer)-1] == ']')) {
		    break;
		}
		if ($bTagFound) {
		    if ($bArrayOut) {
			$buffer = substr($buffer, 0, -1);
			$sRet[] = explode("=", "$buffer");
		    } else {
			if ($bHtml) {
			    $buffer = substr($buffer, 0, -1);
			    $sRet .= "$buffer";
			    $sRet .= '<br>';
			} else {
			    $sRet .= "$buffer";
			}
		    }
		}
	    }
	    fclose($fp);
	}
    }
	
	if ($bTagFound==true)
		return $sRet;
	else
		return '';
}

// 20080402 - Collect javascript content
$jsHeaderFunct = 'var y = window.screen.availHeight - 25      // y coordinate of popup
    var x = window.screen.availWidth - 10       // x coordinate of popup
    var w = 400     // width of popup
    var h = 200     // height of popup
    y -= h
    x -= w

    function submitPopup()
    {
	';
$jsHeaderFunct .= GetFunctContent('submitPopup');
$jsHeaderFunct .= '
    }
	
	var isFilled=false;
	
    fillName = function()
    {
	if (isFilled == false){
	';
$jsHeaderFunct .= GetFunctContent('fillName');
$jsHeaderFunct .= '
	isFilled = true;
	}
	}

    // Kick out frameset
    if (window.self != window.top) {
	window.top.location = window.self.location;
    }
    window.onload = fillName;';

// 20080424 - Collect login page text content
$sCustomLoginRemind = GetLoginTextContent('login_text_path', '[SECTION_REMIND]', true, false);
$sCustomLoginLink = GetLoginTextContent('login_text_path', '[SECTION_LINK]', false, true);
$sCustomLoginTerm = GetLoginTextContent('login_text_path', '[SECTION_TERM]', false, false);

// 20090918 - Add checking of content display
if (isset($disable_show_reminder) && $disable_show_reminder == 1) {
	$sLoginRemind = '';
} elseif ($sCustomLoginRemind != '') {
	$sLoginRemind = $sCustomLoginRemind;
} else {
	$sDefaultLoginRemind = GetLoginTextContent('default_login_text_path', '[SECTION_REMIND]', true, false);
	$sLoginRemind = $sDefaultLoginRemind;
}

if (isset($disable_show_link) && $disable_show_link == 1) {
	$sLoginLink = array();
} elseif ($sCustomLoginLink != '') {
	$sLoginLink = $sCustomLoginLink;
} else {
	$sDefaultLoginLink = GetLoginTextContent('default_login_text_path', '[SECTION_LINK]', false, true);
	$sLoginLink = $sDefaultLoginLink;
}

if (isset($disable_show_tc) && $disable_show_tc == 1) {
	$sLoginTerm = '';
} elseif ($sCustomLoginTerm != '') {
	$sLoginTerm = $sCustomLoginTerm;
} else {
	$sDefaultLoginTerm = GetLoginTextContent('default_login_text_path', '[SECTION_TERM]', false, false);
	$sLoginTerm = $sDefaultLoginTerm;
}
// 20080402 - Create template engine instance
$smarty = new SmartyConnect;
$smarty->assign('J_LOGIN_FORM_HEADER', $jsHeaderFunct);

// 20080331 - Move layout content and include the file here
$smarty->display('login_form_header.tpl');

?>
