<?php

// workaround for allow Internet Explorer 6 or above (p3p browser) to accept your third-party cookie.
header('P3P: CP="CAO PSA OUR"');

// Disable caching of the current document:
header('Cache-Control: no-cache, no-store, max-age=0, must-revalidate');
header('Expires: Mon, 26 Jul 1997 05:00:00 GMT'); // Date in the past
header('Pragma: no-cache');

require_once 'common_functions.php';
require_once 'fs_lang.php';

// 20090617 - Add output buffer
//Get Message
if (file_exists("..\\authserv\\msgByIBMsg.php")) {
	ob_start();
	require_once "..\\authserv\\msgByIBMsg.php";
	ob_end_clean();
}

function getMsg($element)
{
    global $txtmsg;
    if ( isset($txtmsg[$element]) )
        return $txtmsg[$element];
    else
        return "";
}

function writeLog($file, $log)
{
	$fh = fopen($file, "a");
	if ($fh) {
	  flock($fh, LOCK_EX);
	  fwrite($fh, $log."\r\n");
	  flock($fh, LOCK_UN);
	  fclose($fh);
	}
}

$settingobj = new COM('FSCONFIG.Cfgmgr') or die('ibmsgScript.php FSCONFIG.Cfgmgr Object cannot be created!');
$ip_address = $settingobj->getKey( "gateway_IP", "gateway");
$session_handling = $settingobj->getKey( "session_handling", "gateway");

// scenario2 and load balancing
$isScenario2 = $settingobj->getKey('scenario2', 'gateway');
$FOMode=$settingobj->getKey('mode', 'FSFO');
$curr_ID="";

$enableLoadBalancing=0;
if($FOMode == 3){
	$enableLoadBalancing=1;
	$curr_ID = $settingobj->getKey('MachineID', 'FSFO');
}
else if ($isScenario2){
	$curr_ID = $settingobj->getKey('siteID', 'gateway');
}

$conditionSiteID="";

// * siteID must match during using scenario2 or load balancing
if ($isScenario2 || $enableLoadBalancing)
	$conditionSiteID=" siteID ='".$curr_ID."' ";
else
	$conditionSiteID=" siteID is NULL or siteID ='' ";
	
$enableFailover=0;
$condMsgSiteID=""; // format siteID_XXXMachine
$msgSiteID="";
if ($FOMode == 1 || $FOMode == 2){
	$enableFailover=1;
	if ($isScenario2)
		$msgSiteID = $curr_ID."_";
		
	if ($FOMode == 1)
		$msgSiteID .= "MainMachine";
	else if ($FOMode == 2)
		$msgSiteID .= "BackupMachine";
		
	$condMsgSiteID=" siteID ='".$msgSiteID."' ";
	
}

$use_radius = $settingobj->getKey( 'use_radius', 'radius');

// connect to database
if( strtolower($use_radius)== 'true' ) {
    $dsn_file = $settingobj->getKey( 'Datasource', 'radius');
}else{
	$dsn_file = $settingobj->getKey( 'Datasource', 'gateway');
}

$dsn_source = fopen($dsn_file, 'r') or die('Cannot open DSN source file!');  
$dsn='';

if(!feof($dsn_source)) 
    $line=fgets($dsn_source,512); 

while(!feof($dsn_source)) {
    $line=fgets($dsn_source,512);
    if (trim($line)!='') $dsn.=$line;
}

$dsn=str_replace("\r\n",';',$dsn);

$ibmsg_tablename = $settingobj->getKey('Datasource_ibmsg_Tablename', 'gateway');

$scriptPort = $settingobj->getKey('script_port', 'IB');

// Determine show IP or domain name
$showDomainUrl = $settingobj->getKey("show_domain_URL", "gateway");
//* using HTTP only
if (isset($showDomainUrl) && $showDomainUrl > 0) {
    // $urlhead = fs_local_domain_url();
	$versionType = $settingobj->getKey('version', 'version');
	if (substr_count(strtolower($versionType), 'start') > 0 || substr_count(strtolower($versionType), 'standard') > 0) {
		$dn = 'firstspot.org';
	} else {
		$dn = $settingobj->getKey("gateway_domain", "gateway");
		if ($dn == '') {
			$dn = 'firstspot.org';
		}
	}
	$head="http://";
	$urlhead = $head.$dn;
} else {
    // $urlhead = fs_local_ip_url();
	$ip_address = $settingobj->getKey( "gateway_IP", "gateway");
	$head="http://";
	$urlhead = $head.$ip_address;
}

$iBMsg = $settingobj->getKey("iBMsg", "IB");
$iBMsg_remindMin = $settingobj->getKey("iBMsg_remindMin", "IB");

$isIBMsgReminderEnable = 0;
if ($iBMsg_remindMin >0){
	$isIBMsgReminderEnable = 1;
}

$session_limit = $settingobj->getKey( 'sessionlimit', 'gateway');

// new for commercial break
$iB_cb_redirect = $settingobj->getKey("iB_cb_redirect", "IB");

$isIBRedirect=0;
if ($iB_cb_redirect == 1&& isset($_GET['state']) && ($_GET['state'] == 2 || $_GET['state'] == 3)){
	$isIBRedirect =1;
}

// new for show infobox information
$iBMsg_infobox_mode = $settingobj->getKey("iBMsg_infobox_mode", "IB");

$isIBMsgShowInfo = 0;
$isIBMsgInfoboxAlwaysOn = 0;
if ($iBMsg_infobox_mode == 1){
	$isIBMsgShowInfo = 1;
}
else if ($iBMsg_infobox_mode == 2){
	$isIBMsgShowInfo = 1;
	$isIBMsgInfoboxAlwaysOn = 1;
}

$anon_infobox=0; // 1: It is Anonymous Infobox
if (fs_is_anonymous_mode()){
	// anonymous infobox use
	$anon_infobox=1;
}
$print_support = $settingobj->getKey( 'PrintSupport', 'PrinterOn');

// banner
$iB_banner_mode = $settingobj->getKey("iB_banner_mode", "IB");
$iB_banner_type = $settingobj->getKey("iB_banner_type", "IB");
$iB_banner_img_count = $settingobj->getKey("iB_banner_img_count", "IB");
$iB_banner_frame_w = $settingobj->getKey("iB_banner_frame_w", "IB");
$iB_banner_frame_h = $settingobj->getKey("iB_banner_frame_h", "IB");

$settingobj=null;

// format hard code: Time_ID
$spChar ="_";

$url="";

$banner_frame_file="sample_top_banner.php";

// checking this page call from fsRedirector (match private ip and server name)
if(isset($_SERVER['REMOTE_ADDR']) && $_SERVER['REMOTE_ADDR'] == $ip_address && isset($_SERVER['HTTP_SERVER']) && $_SERVER['HTTP_SERVER'] == "FirstSpotDispatcher"){
	if (isset($_GET['request']) && $_GET['request'] != "none" && isset($_GET['patronsoft1']) &&  isset($_GET['patronsoft2'])){
	
		$userDB=odbc_connect($dsn,'','');
		
		$reserved1="";
		$q="";
		
		$macOrIp_str="";
		
		$userStr="";
		$hvMsg = 0; // 1: have messge to show 
		
		$hvReminder = 0;
		$hvGlobalMsg = 0;
		$hvPersonalmsg = 0;
		$hvTimeBasedMsg = 0;
		
		$g_curr_contentRefID = 0;
		$g_curr_ibmsgID = 0;
		$g_curr_ibmsgTime = 0;
		$g_next_ibmsgID = 0;
		$g_next_ibmsgTime = 0;
		
		$p_curr_contentRefID = 0;
		$p_curr_ibmsgID = 0;
		$p_curr_ibmsgTime = 0;
		$p_next_ibmsgID = 0;
		$p_next_ibmsgTime = 0;
		
		$remainTime = -1;
		
		if ($session_handling == 1){
			$reserved1=$_GET['patronsoft1'];
			$macOrIp_str=long2ip($reserved1);
			$ip = explode(".",$macOrIp_str);
			$macOrIp_str=$ip[3].".".$ip[2].".".$ip[1].".".$ip[0];
		}else{
			$reserved1=$_GET['patronsoft2'];
			$macOrIp_str=make_mac_name($reserved1);
		}
		
		$q = 'select * from '.fs_usr_table()." where reserved1 = '".$reserved1."' and (".$conditionSiteID.");";

		$result = odbc_exec( $userDB, $q );
		$username = odbc_result( $result, 'name' );
		$userIBMsgGlobalState = odbc_result( $result, 'iBMsg_glo' );
		
		$userIBMsgGlobalState_time =0;
		$userIBMsgGlobalState_id = 0;
		
		if ($userIBMsgGlobalState != "" && strpos($userIBMsgGlobalState, $spChar) != 0){
			list($userIBMsgGlobalState_time, $userIBMsgGlobalState_id) = explode($spChar, $userIBMsgGlobalState);
		}
		
		$userIBMsgPersonalState = odbc_result( $result, 'iBMsg_per' );
		
		$userIBMsgPersonalState_time =0;
		$userIBMsgPersonalState_id = 0;
		
		if ($userIBMsgPersonalState != "" && strpos($userIBMsgPersonalState, $spChar) != 0){
			list($userIBMsgPersonalState_time, $userIBMsgPersonalState_id) = explode($spChar, $userIBMsgPersonalState);
		}
		
		$recur_option=0;
		$recur_option = "";
		$recur_stime = "";
		$recur_etime = "";
		
		if (strtolower($use_radius)!= 'true'){ // NOT RADIUS
			$resetopt = odbc_result($result, 'resetopt');
			$recur_option = odbc_result($result, 'roption');
			$recur_stime = odbc_result($result, 'rsdate');
			$recur_etime = odbc_result($result, 'redate');		
		}
		
		$logintime=odbc_result($result,'reserved2');
		$expiryDate = odbc_result($result,'edate');
		$timeleft=odbc_result($result,'timeleft');
		$expiryDate = odbc_result($result,'edate');
		
		// checking have reminder
		if ($isIBMsgReminderEnable){
			
			$userArray = array();
			if (isset($expiryDate))
				$userArray['expiryDate']=$expiryDate;
			if (isset($recur_option))
				$userArray['recur_option']=$recur_option;
			if (isset($recur_stime))
				$userArray['recur_stime']=$recur_stime;
			if (isset($recur_etime))
				$userArray['recur_etime']=$recur_etime;
			if (isset($logintime))
				$userArray['logintime']=$logintime;
			if (isset($session_limit))
				$userArray['session_limit']=$session_limit;
			// timeleft (not edit or calculate before)
			if (isset($timeleft) && strlen($timeleft) > 0 && $timeleft >= 0 && isset($logintime)){
				$userArray['max_time']=$timeleft;
			}
			
			$remainTimeSec = cal_timeleft_reminder($userArray);
			
			if ($remainTimeSec != -1){
				$remainTime = floor($remainTimeSec/60);
				if ($remainTime <= $iBMsg_remindMin ){
					$hvReminder = 1;
					$hvMsg = 1;
				}
			}
		}
		
		odbc_free_result( $result );
		
		// checking show infobox information
		if ($isIBMsgShowInfo){

			// for infobox use
			if(!session_id()) {
				session_start();
			}
			
			//* (IE 6 or above)before using session variable, need apply workaround of p3p browser
			$_SESSION['sess_patronsoft2']=$reserved1;
			
			// $url=$urlhead.'/info.php';
			
			// special for: can't overcome problem of set cross domain cookie eg. safari 
			$url=$urlhead.'/info.php?type=1&p2='.$reserved1;

			$hvMsg = 1;
		}
		
		if ($username != ""){
		
			$cond1="";
			if ($enableFailover)
				$cond1 = $condMsgSiteID;
			else
				$cond1 = $conditionSiteID;
		
			$q = "select * from ".$ibmsg_tablename." where ((ibmsgTime >= ".$userIBMsgGlobalState_time." and ibmsgType = 1) or  (ibmsgTime >= ".$userIBMsgPersonalState_time." and ibmsgType = 2 and (name  = '".$username."' or reserved1 = '".$reserved1."'))) and (".$cond1.") order by ibmsgType, ibmsgTime, ibmsgID ;";
			$result = odbc_exec( $userDB, $q );
			
			while (odbc_fetch_row($result)) 
			{
				$ibmsgID=odbc_result($result,"ibmsgID");
				$ibmsgType=odbc_result($result,"ibmsgType");
				$ibmsgTime=odbc_result($result,"ibmsgTime");
				// checking have Global 
				if ($hvGlobalMsg == 0 && $ibmsgType == 1 && ($ibmsgTime> $userIBMsgGlobalState_time || ($ibmsgTime ==  $userIBMsgGlobalState_time && $ibmsgID > $userIBMsgGlobalState_id ))){
					$hvGlobalMsg = 1;
					// * using floor() to avoid dbase number value = x.0 instead of an integer
					$g_curr_contentRefID=floor(odbc_result($result,"conRefID"));
					$g_curr_ibmsgID=$ibmsgID;
					$g_curr_ibmsgTime=$ibmsgTime;
					$hvMsg = 1;
				}
				else if ($hvGlobalMsg == 1 && $ibmsgType == 1 && $g_next_ibmsgID == 0 && ($ibmsgTime> $userIBMsgGlobalState_time || ($ibmsgTime ==  $userIBMsgGlobalState_time && $ibmsgID > $userIBMsgGlobalState_id ))){
					// Next 
					$hvGlobalMsg = 2;
					$g_next_ibmsgID=$ibmsgID;
					$g_next_ibmsgTime=$ibmsgTime;
				}
				
				// checking have Personal
				if ($hvPersonalmsg == 0 && $ibmsgType == 2 && ($ibmsgTime> $userIBMsgPersonalState_time || ($ibmsgTime ==  $userIBMsgPersonalState_time && $ibmsgID > $userIBMsgPersonalState_id ))){
					$hvPersonalmsg = 1;
					$p_curr_contentRefID=floor(odbc_result($result,"conRefID"));
					$p_curr_ibmsgID=$ibmsgID;
					$p_curr_ibmsgTime=$ibmsgTime;
					$hvMsg = 1;
				}
				else if ($hvPersonalmsg == 1 && $ibmsgType == 2 && $p_next_ibmsgID == 0 && ($ibmsgTime> $userIBMsgPersonalState_time || ($ibmsgTime ==  $userIBMsgPersonalState_time && $ibmsgID > $userIBMsgPersonalState_id ))){
					// Next 
					$hvPersonalmsg = 2;
					$p_next_ibmsgID=$ibmsgID;
					$p_next_ibmsgTime=$ibmsgTime;
				}
			}
			
			odbc_free_result( $result );
			
			if ($_GET['request'] == "mark" || !$hvMsg){
			
				$isCancel = -1;
				
				if ($hvMsg){
					// global 
					if ($g_curr_ibmsgID > 0){
						if (isset($_GET['g'])){
							$markIBMsgGlobalState_time =0;
							$markIBMsgGlobalState_id = 0;
							if ($_GET['g'] != "" && strpos($_GET['g'], $spChar) != 0){
								list($markIBMsgGlobalState_time, $markIBMsgGlobalState_id) = explode($spChar, $_GET['g']);
							}
							
							if ($markIBMsgGlobalState_time> $g_curr_ibmsgTime){
								// message record may be deleted and dont have any new in-browser message
								$isCancel = 1;
							}
							else if ($markIBMsgGlobalState_time ==  $g_curr_ibmsgTime && $markIBMsgGlobalState_id == $g_curr_ibmsgID ){
								// close action match current state
								$q = 'update '.fs_usr_table()." set iBMsg_glo = '".$_GET['g']."' where reserved1 = '".$reserved1."' and (".$conditionSiteID.") ;";
								$result = odbc_exec( $userDB, $q );
								odbc_free_result( $result );
								// echo "alert (\"Global: Updated Value\");";
								// writeLog("ibmsgScript.log", "Global: Updated Value");
								
								if ($g_next_ibmsgID == 0){
									// dont have any new in-browser message
									$isCancel = 1;
								}
								else{
									// have next in-browser message
									$isCancel = 0;
								}
							}
							else if ($markIBMsgGlobalState_time <  $g_curr_ibmsgTime || ($markIBMsgGlobalState_time ==  $g_curr_ibmsgTime && $markIBMsgGlobalState_id < $g_curr_ibmsgID ) ){
								// close action not match current state, may be tmarked's message is deleted before 
								$isCancel = 0;
							}
						}
						else{
							// have global in-browser message, but close action not contain 
							$isCancel = 0;
						}
					}
					
					// personal
					if ($p_curr_ibmsgID > 0){
						if (isset($_GET['p'])){
							$markIBMsgPersonalState_time =0;
							$markIBMsgPersonalState_id = 0;
							if ($_GET['p'] != "" && strpos($_GET['p'], $spChar) != 0){
								list($markIBMsgPersonalState_time, $markIBMsgPersonalState_id) = explode($spChar, $_GET['p']);
							}
							
							if ($markIBMsgPersonalState_time> $p_curr_ibmsgTime){
								// message record may be deleted and dont have any new in-browser message
								if ($isCancel != 0)
									$isCancel = 1;
							}
							else if ($markIBMsgPersonalState_time ==  $p_curr_ibmsgTime && $markIBMsgPersonalState_id == $p_curr_ibmsgID ){
								// close action match current state
								$q = 'update '.fs_usr_table()." set iBMsg_per = '".$_GET['p']."' where reserved1 = '".$reserved1."' and (".$conditionSiteID.");";
								$result = odbc_exec( $userDB, $q );
								odbc_free_result( $result );
								// echo "alert (\"Personal: Updated Value\");";
								// writeLog("ibmsgScript.log", "Personal: Updated Value");
								
								if ($p_next_ibmsgID == 0){
									// dont have any new in-browser message
									if ($isCancel != 0)
										$isCancel = 1;
								}
								else{
									// have next in-browser message
									$isCancel = 0;
								}
							}
							else if ($markIBMsgPersonalState_time <  $p_curr_ibmsgTime || ($markIBMsgPersonalState_time ==  $p_curr_ibmsgTime && $markIBMsgPersonalState_id < $p_curr_ibmsgID ) ){
								// close action not match current state, may be tmarked's message is deleted before 
								$isCancel = 0;
							}
						}
						else{
							// have personal in-browser message, but close action not contain 
							$isCancel = 0;
						}
					}
					
					if ($isCancel != 0){
						if ($hvReminder == 1){
							$isCancel = 1;
						}
					}
					
					if ($isCancel == -1 && $isIBMsgShowInfo){
						$isCancel = 1;
					}
					
				}
				else{
					$isCancel = 1;
				}
				
				if ($isIBRedirect || (!$hvMsg && $iB_banner_mode == 1 && !($_GET['request'] == "mark"))){ // commercial break or (banner mode + no msg + not "mark" request)
					// echo "alert (\"Skip exit, (cb redirect or banner mode on with no message and not mark request)\");";
					// writeLog("ibmsgScript.log", "Skip exit, (cb redirect or banner mode on with no message and not mark request)");
				}
				else{
					if ($isCancel == 1){
						if (!$isIBMsgInfoboxAlwaysOn && !($iB_banner_mode == 1)){
							// create a COM object
							$myobj = new COM('FSAUTH.Authserv') or die('ibmsgScript.php FSAUTH.Authserv object cannot be created!');
							$myobj->CancelIBMsgByBM($reserved1);
							$myobj=null;
							// echo "alert (\"Mark Cancel\");";
							// writeLog("ibmsgScript.log", "Mark Cancel");
						}
						else{
							// echo "alert (\"Skip Mark Cancel, (infobox always on or banner mode on)\");";
							// writeLog("ibmsgScript.log", "Skip Mark Cancel, (infobox always on or banner mode on)");
						}
					}
					exit();
				}
			}
			
			// if (strtolower($use_radius) != 'true'){
				// // For passive login 
				// $q = 'select count(*) as num from '.fs_usr_table()." where name = '".$username."' AND MACasUsr='Y' AND pwd is null ;";	
				// $result = odbc_exec( $userDB, $q );
				// $isPassiveLogin = odbc_result( $result, 'num' );
				// odbc_free_result( $result );
				// odbc_close( $userDB );
				// if($isPassiveLogin>0){
					// // passive login
				// }else{
				// }
			// }
		}
		else{
			// not logged in
			if ($_GET['request'] == "mark"){
				// echo "alert (\"Username not found\");";
				// writeLog("ibmsgScript.log", "Username not found");
				exit();
			}
		}
		
		$isExceptionCase = 0;
		if (checking_ua($_SERVER['HTTP_USER_AGENT']) == 1){
	        $isExceptionCase = 1;
		}
		
		// prevent the stfing contain "Special Character Definitions" of  "\n newline (LF, NL)"
		function jsspecialchars( $string = '') {
			$string = preg_replace("/\r*\n/","\\n",$string);
			return $string;
		}
		
		// prevent the stfing contain "Special Character Definitions" of  "\n newline (LF, NL) AND single quota(')"
		function jsspecialchars2( $string = '') {
			$string = preg_replace("/\r*\n/","\\n",$string);
			$string = preg_replace("/'/","\\\'",$string);
			return $string;
		}
		
		$responseParam="";
		// * g= global, r= reminder, p = personal		
		$g_msg_title="";
		$g_msg_txt="";
		$p_msg_title="";
		$p_msg_txt="";
		$r_msg_txt="";
		
		if ($isIBRedirect){
			$responseParam="/?request=cb&url=";
		}
		else{
			$responseParam="/?request=mark";
			
			// ------Message-----
			
			// 20090617 - Modify backslash process
			if ($hvGlobalMsg){
				$g_msg_title .= str_replace("\\", "&#92;", jsspecialchars(htmlspecialchars_decode(getMsg("ibmsg_g_title_".$g_curr_contentRefID))));
				$g_msg_txt .= str_replace("\\", "&#92;", jsspecialchars(htmlspecialchars_decode(getMsg("ibmsg_g_msg_".$g_curr_contentRefID))));
				$responseParam.="&g=".floor($g_curr_ibmsgTime).$spChar.floor($g_curr_ibmsgID);
			}
			
			if ($hvPersonalmsg){
				$p_msg_title .= str_replace("\\", "&#92;", jsspecialchars(htmlspecialchars_decode(getMsg("ibmsg_g_title_".$p_curr_contentRefID))));
				$p_msg_txt .= str_replace("\\", "&#92;", jsspecialchars(htmlspecialchars_decode(getMsg("ibmsg_g_msg_".$p_curr_contentRefID))));
				$responseParam.="&p=".floor($p_curr_ibmsgTime).$spChar.floor($p_curr_ibmsgID);
			}
			
			if ($hvReminder){
				$responseParam.="&r=1";
				if (isset($remainTime)){
					if ($remainTime> 0){
						$r_msg_txt.=$remainTime." ".get_var('reminder_msg');
					}
					else{
						$r_msg_txt.="Less than 1 ".get_var('reminder_msg');
					}
				}
			}

			//-------END----------
		}
		
		?>
		<?echo "//";?><script type="text/javascript">
		var xmlHttp;
		
		var isInject = false;
		
		var currentClientHeight = 0;
		var currentClientWidth = 0;
		var waitShow = false;
		
		isLoaded = true;
		
		function getScript(url)
		{
			var s = document.createElement('SCRIPT');
			s.src = url;
			document.body.appendChild(s);
		}

		function w1(t, str)
		{
			var s = document.createElement('DIV');
			s.id = t;
			document.body.appendChild(s);
			
			document.getElementById(t).innerHTML = str;
		}
		
		function wi2(t, str)
		{
			document.getElementById(t).innerHTML = str;
		}
		
		function wcss(){
			var headID = document.getElementsByTagName("head")[0];         
			var cssNode = document.createElement('link');
			cssNode.type = 'text/css';
			cssNode.rel = 'stylesheet';
			cssNode.href = "<?=$urlhead.'/ibmsgDisplay.css'?>";
			headID.appendChild(cssNode);
		}
		
		function mbpT(h){
			document.body.style.paddingTop=h;
		}
		
		var s=""
		
		// look and feel and strust of the message
		<?php include "ibmsgDisplay.php";?>
		
		s = '<?echo jsspecialchars2($msgContent);?>';
		
		if (window.top==window.self){
			
			<?if ($isIBRedirect){
				$redirectLink="";
				if ($isExceptionCase){
					$redirectLink=$responseParam;
				}
				else{
					$redirectLink=$urlhead.":".$scriptPort.$responseParam;
				}
			?>
				var l=window.location;
				window.location = "<?=$redirectLink?>"+l;
			<?} else{?>
				wi2("aTag",s);
				<?
				// *default div of fsib will not display
				if ($hvGlobalMsg || $hvPersonalmsg || $hvReminder){
					// max message box
					echo "maxMsgBox();";
				}
				else{
					// hide message box
					echo "hideMsgBox();";
				}
				if ($isIBMsgShowInfo){
					// minimize infobox
					echo "minInfoTag();";
				}
				else{
					// hide infobox
					echo "hideInfoTag();";
				}
				?>
			<?}?>
			wcss();
			
			sb ="";
			<?if($iB_banner_mode == 1){
			// banner width and height
			$bnW =0;
			$bnH =0;
			
			if ($iB_banner_type == 1){
				// show image  banner
				$folder="/bn_pic/";
				$f_path='../authserv'.$folder;
				$banner_pic_file="";
				$hvLink=false;
				
				$random_no = gen_random_no($iB_banner_img_count);
				
				$settingobj = new COM('FSCONFIG.Cfgmgr') or die('setcfg.php FSCONFIG.Cfgmgr Object cannot be created!');
				$banner_pic_file=$settingobj->getKey("iB_banner_img".$random_no,'IB');
				$linkTo=$settingobj->getKey("iB_banner_img_html".$random_no,'IB');
				$settingobj=null;
				
				$img_width=0;
				$img_height=0;
				
				// prevent file not exist
				if (file_exists($f_path.$banner_pic_file))
					list($img_width, $img_height, $img_type, $img_attr) = getimagesize($f_path.$banner_pic_file);
				if ($img_width >0)
					$bnW = $img_width;

				if ($img_height >0)
					$bnH = $img_height;
					
				if ($linkTo!="")
					$hvLink = true;
				
				if ($hvLink == true){
					?>sb+='<a href="<?=$linkTo?>" target="_top">';<?
				}
				?>
				sb+='<img border="0" title="" alt="" src="<?=$urlhead.$folder.$banner_pic_file?>" width="<?=$bnW?>px" height="<?=$bnH?>px"/>';
				<?
				if ($hvLink == true){
					?>sb+='</a>';<?
				}
			}
			else if ($iB_banner_type == 2){
				// show  banner frame
				if ($iB_banner_frame_w >0)
					$bnW = $iB_banner_frame_w;
				if ($iB_banner_frame_h >0)
					$bnH = $iB_banner_frame_h;
				?>
					sb='<iframe id="frameA" src="<?=$urlhead?>/cb_frame.php?file=<?=$banner_frame_file?>" frameborder="0" marginwidth="0" marginheight="0" scrolling="no" width="<?=$bnW?>px" height="<?=$bnH?>px"></iframe>';
					// * init width and height to 1px, later will be adjust the frame size
					// sb='<iframe id="frameA" onLoad="adjustIFrameSize();" src="/?request=ibmsg&domain='+document.domain+'&file=sample_top_banner.php" frameborder="0" marginwidth="0" marginheight="0" scrolling="no" scroll="no" width="1px" height="1px"></iframe>';	
				<?	
			}
			?>
			try{
			if (sb!=""){
			
				function GetDocumentWidth()
				{
					// alert("document.body.scrollWidth = "+document.body.scrollWidth+"\n"+"document.documentElement.scrollWidth = "+document.documentElement.scrollWidth+"\n"+"document. body.offsetWidth = "+document. body.offsetWidth+"\n"+"document.documentElement.offsetWidth = "+document.documentElement.offsetWidth+"\n"+"document.body.clientWidth = "+document.body.clientWidth+"\n"+"document.documentElement.clientWidth = "+document.documentElement.clientWidth+"\n"+ "document.body[scrollWidth] = "+document.body["scrollWidth"]+"\n"+"document.documentElement[scrollWidth] = "+document.documentElement["scrollWidth"]+"\n"+"document.body[offsetWidth] = "+document.body["offsetWidth"]+"\n"+"document.documentElement[offsetWidth] = "+document.documentElement["offsetWidth"]+"\n"+"document.body[clientWidth] = "+document.body["clientWidth"]+"\n"+"document.documentElement[clientWidth] = "+document.documentElement["clientWidth"]+"\n");
				
					rs = 0;
					try {
						rs = Math.max(document.body.scrollWidth, document.documentElement.scrollWidth, document. body.offsetWidth, document.documentElement.offsetWidth, document.body.clientWidth, document.documentElement.clientWidth);
					}
					catch (e){
						// error
					}
					return rs;
				};
				
				// hide banner element
				function hideBanner(wo){
					document.getElementById("fsBnI").style.visibility="hidden";
					document.getElementById("fsBnI").style.display="none";
					if (wo == false)
					{
						document.getElementById("dumDiv").style.visibility="hidden";
						document.getElementById("dumDiv").style.display="none";
					}
				};
				
				// show banner element
				function ShowBanner(wo){
					document.getElementById("fsBnI").style.visibility="visible";
					document.getElementById("fsBnI").style.display="";
					if (wo == false)
					{
						document.getElementById("dumDiv").style.visibility="visible";
						document.getElementById("dumDiv").style.display="";
					}
				};
				
				// modify banner element width and then show it again
				function runShow(){
					document.getElementById("T1").width = GetDocumentWidth();
					ShowBanner(false);
					waitShow = false;
				};
				
				function resizeWithWait()
				{
					try{
						if (currentClientHeight != document.body.clientHeight || currentClientWidth != document.body.clientWidth ) {
							if (waitShow == false){
								// alert("Change");
								waitShow = true;
								hideBanner(false);
								setTimeout( runShow, 100 );
							}
							else{
								// alert("Already");
							}
						}
						else{
							// alert("No Change");
						}
						currentClientWidth = document.body.clientWidth;
						currentClientHeight = document.body.clientHeight;
					}
					catch (err){
					}
				};
				
				function resizeNoWait()
				{
					try{
						waitShow = true;
						hideBanner(false);
						runShow();
					}
					catch (err){
					}
				};
				
				function injectBnContent()
				{
				
				if (isInject == true){
					// already added
					return ;
				}
				
				isInject = true;
				
				// add dummy div 
				var divDum = document.createElement("DIV");
				divDum.id = "dumDiv";
				divDum.scrolling = "no";
				divDum.style.width = "100%"; // use for checking resize in ie
				divDum.style.height = "<?=$bnH?>px";
				
				bodyID = document.getElementsByTagName("body")[0];
				add = bodyID.childNodes[0] ;
				add.parentNode.insertBefore(divDum, add);
				
				// attach resize event
				if(document.all) { // for IE
					var Container = document.getElementById("dumDiv");
					Container.attachEvent("onresize",resizeWithWait);
				} else { // for Mozilla
					// The onresize event occurs when a window or frame is resized.
					window.onresize = resizeNoWait;
				}
				
				// add div
				var divCon = document.createElement("DIV");
				
				divCon.id = "fsBnI";
				divCon.scrolling = "no";
				
				bodyID = document.getElementsByTagName("body")[0];
				add = bodyID.childNodes[0] ;
				add.parentNode.insertBefore(divCon, add);
				
				newsb = "<table width=\""+GetDocumentWidth()+"px\" border=\"0\" id=\"T1\"><tr><td align=\"center\" style=\"text-align:center;\">"+sb+"</td></tr></table>";
				
				document.getElementById("fsBnI").innerHTML = newsb;
				}
				
				// different with injectBnContent(), not adjust when resize, no dump div
				function injectBnContentWithoutDump()
				{
				
				if (isInject == true){
					// already added
					return ;
				}
				
				isInject = true;
				
				// add div
				var divCon = document.createElement("DIV");
				
				divCon.id = "fsBnI";
				divCon.scrolling = "no";
				
				bodyID = document.getElementsByTagName("body")[0];
				add = bodyID.childNodes[0] ;
				add.parentNode.insertBefore(divCon, add);
				
				newsb = "<table width=\""+GetDocumentWidth()+"px\" border=\"0\" id=\"T1\"><tr><td align=\"center\" style=\"text-align:center;\">"+sb+"</td></tr></table>";
				
				document.getElementById("fsBnI").innerHTML = newsb;
				};
				
				// Mozilla, Opera webkit which support this event
				if ( document.addEventListener ) {
					// DOMContentLoaded : Opera and Mozilla fire a DOMContentLoaded event which runs after the page has loaded but before all the slow images and applets and Flash movies need to load, which is perfect
					document.addEventListener( "DOMContentLoaded", function(){
						document.removeEventListener( "DOMContentLoaded", arguments.callee, false );
						// do Action
						injectBnContent();
					}, false );
				}
				// IE support 
				else if ( document.attachEvent ) {
					document.attachEvent("onreadystatechange", function(){
						// set to complete to ensure that the behavior is completely downloaded and applied to the element
						if (document.readyState=="complete")
						{
							// Finish initialization.
							document.detachEvent( "onreadystatechange", arguments.callee );
							// do Action
							injectBnContent();
						}
					});
					
					// trick by Diego Perini (http://javascript.nwbox.com/IEContentLoaded/)
					// IE with no iframe, because of  problem"iframe that contains a large image that downloads slowly"
					if ( document.documentElement.doScroll && window == window.top ) (function(){
						try {
														document.documentElement.doScroll("left");
						} catch( error ) {
							setTimeout( arguments.callee, 0 );
							return;
						}
						
						// do Action
						injectBnContent();
					})();
				}
				else{
					// not support
					// alert("not support");
					injectBnContentWithoutDump();
				}
				
			}
			
			}
			catch (err){
				// txt="There was an error on this page.\n\n";
				// txt+="Error description: " + err.description + "\n\n";
				// txt+="Click OK to continue.\n\n";
				// alert(txt);
				
				newsb = "<table width=\""+GetDocumentWidth()+"px\" border=\"0\" id=\"T1\"><tr><td align=\"center\">"+sb+"</td></tr></table>";
				
				// workaround for fail to insert iframe by using "insertBefore" XML DOM method (insert only, position will not be adjust)
				
				document.getElementById("bTag").innerHTML = newsb;
				
				// wi2("bTag", newsb);
				
			}
			<?
			}
			?>
		}
		
		// Message
		function hideMsgBox(){
			document.getElementById("trTitle").style.visibility="hidden";
			document.getElementById("trTitle").style.display="none";
			document.getElementById("tdMsg").style.visibility="hidden";
			document.getElementById("tdMsg").style.display="none";
			document.getElementById("maxBtn").style.visibility="";
			document.getElementById("maxBtn").style.display="";
			document.getElementById("minBtn").style.visibility="hidden";
			document.getElementById("minBtn").style.display="none";
		}
		
		function closeMsgBox(t){
			if (<?=$isExceptionCase?> == 1){
				notifyClosedByXMLHTTP();
			}
			else{
				getScript("<?=$urlhead?>:<?=$scriptPort?><?=$responseParam?>");
			}
			// document.getElementById(t).style.visibility="hidden";
			hideMsgBox();
		}
		
		function minMsgBox(){
			document.getElementById("tdMsg").style.visibility="hidden";
			document.getElementById("tdMsg").style.display="none";
			document.getElementById("maxBtn").style.visibility="";
			document.getElementById("maxBtn").style.display="";
			document.getElementById("minBtn").style.visibility="hidden";
			document.getElementById("minBtn").style.display="none";
			document.getElementById("fsib").style.visibility="";
			document.getElementById("fsib").style.display="";
		}
		
		function maxMsgBox() {
			document.getElementById("tdMsg").style.visibility="";
			document.getElementById("tdMsg").style.display="";
			document.getElementById("maxBtn").style.visibility="hidden";
			document.getElementById("maxBtn").style.display="none";
			document.getElementById("minBtn").style.visibility="";
			document.getElementById("minBtn").style.display="";
			document.getElementById("fsib").style.visibility="";
			document.getElementById("fsib").style.display="";
		}
		
		// Infobox
		function hideInfoTag(){
			document.getElementById("trInfoTitle").style.visibility="hidden";
			document.getElementById("trInfoTitle").style.display="none";
			document.getElementById("tdInfo").style.visibility="hidden";
			document.getElementById("tdInfo").style.display="none";
			document.getElementById("maxBtn2").style.visibility="hidden";
			document.getElementById("maxBtn2").style.display="none";
			document.getElementById("minBtn2").style.visibility="hidden";
			document.getElementById("minBtn2").style.display="none";
		}
		
		function closeInfoTag(t){
			// comment, since no action when click iin-browser infobox close button
			// if (<?=$isExceptionCase?> == 1){
				// notifyClosedByXMLHTTP();
			// }
			// else{
				// getScript("<?=$urlhead?>:<?=$scriptPort?><?=$responseParam?>");
			// }			
			hideInfoTag();
		}
		
		function minInfoTag(){
			// document.getElementById("infoFrame").style.display = 'none';
			
			// * set fsib first (workaround for infobox not show in mobile) 
			document.getElementById("fsib").style.visibility="";
			document.getElementById("fsib").style.display="";
			
			document.getElementById("tdInfo").style.visibility="hidden";
			document.getElementById("tdInfo").style.display="none";
			document.getElementById("maxBtn2").style.visibility="visible";
			document.getElementById("maxBtn2").style.display="";
			document.getElementById("minBtn2").style.visibility="hidden";
			document.getElementById("minBtn2").style.display="none";
			// document.getElementById("infoFrame").src="about:blank";
			ss ="";
            wi2('infoFrameTag', ss);
		}
		
		function maxInfoTag() {
			// document.getElementById("infoFrame").style.display = "";
			document.getElementById("tdInfo").style.visibility="visible";
			document.getElementById("tdInfo").style.display="";
			document.getElementById("maxBtn2").style.visibility="hidden";
			document.getElementById("maxBtn2").style.display="none";
			document.getElementById("minBtn2").style.visibility="visible";
			document.getElementById("minBtn2").style.display="";
			document.getElementById("fsib").style.visibility="";
			document.getElementById("fsib").style.display="";
			iframe='<?=$url?>';
			// document.getElementById("infoFrame").src=iframe;
			ss = '<iframe id="infoFrame2" name="infoFrame2" src="'+iframe+'" width="400" height="200" frameborder="0" marginwidth="0" marginheight="0" scrolling="no"></iframe>';
            wi2('infoFrameTag', ss);
		}
		
		function GetXmlHttpObject()
		{
		var objXMLHttp=null
		if (window.XMLHttpRequest)
		{
		objXMLHttp=new XMLHttpRequest()
		}
		else if (window.ActiveXObject)
		{
		objXMLHttp=new ActiveXObject("Microsoft.XMLHTTP")
		}
		return objXMLHttp
		}
		
		function notifyClosedByXMLHTTP()
		{
		xmlHttp=GetXmlHttpObject()
		if (xmlHttp==null)
		{
		alert ("Browser does not support HTTP Request")
		return
		}
		var url="<?=$responseParam?>";
		url=url+"&sid="+Math.random() // Adds a random number to prevent the server from using a cached file
		xmlHttp.onreadystatechange=xmlHttpStateChanged // function will process the response from a server
		try{
		xmlHttp.open("GET",url,true)
		xmlHttp.send(null)
		}
		catch (e){
		txt="There was an error on this page.\n\n";
		txt+="Error description: " + err.description + "\n\n";
		txt+="Click OK to continue.\n\n";
		alert(txt);

		}
		}
		
		function xmlHttpStateChanged() 
		{ 
		// readyState
		// State	Description
		// 0	The request is not initialized
		// 1	The request has been set up
		// 2	The request has been sent
		// 3	The request is in process
		// 4	The request is complete
		if (xmlHttp.readyState==4 || xmlHttp.readyState=="complete")
		{
		xmlDoc=xmlHttp.responseXML;
		// alert (xmlHttp.responseText); // all xml content
		var str = '<script ype="text/JavaScript">'+xmlHttp.responseText+'<\/script>';
		w1("rTag",str);
		}
		}

	<?echo "//";?></script>
		<?
		exit();
	}else{
		// print_r ($_GET);
		// echo "ERROR 1";
		exit();
	}
}else{
	// print_r ($_GET);
	// echo "ERROR 2";
	exit();
}

?>
