// 20090430 - Javescript functions called from urllog.php and urllog_entry.php

var sortReady = false;
var timer;

// Perform sorting according to the inputted column in ascending order
function AscSortTableCol(colIndex)
{
	// Obtain target table object
	var oTables = parent.frames[0].document.getElementsByTagName('TABLE');
	var oTable = oTables[0];

	if (oTable) {
		var aRow = new Array();

		// Obtain row entries
		with (oTable) {
			for (var i = 0; i < rows.length; i++) {
				aRow[i] = rows[i];
			}
		}

		// Check which column should be used for sorting
		switch (colIndex) {
			case 0:
				aRow.sort(CompareName);
				break;
			case 1:
				aRow.sort(CompareLogin);
				break;
			case 2:
				aRow.sort(CompareMAC);
				break;
			case 3:
				aRow.sort(CompareSrcIP);
				break;
			case 4:
				aRow.sort(CompareDstPort);
				break;
			case 5:
				aRow.sort(CompareDstIP);
				break;
			case 6:
				aRow.sort(CompareURL);
		}

		// Put the sorted results back to DOM
		if (oTable.tBodies[0]) {
			with (oTable.tBodies[0]) {
				for (var i = 0; i < aRow.length; i++) {
					appendChild(aRow[i]);
				}
			}
		}
	}
	sortReady = true;
}

// Sort function for the name column
function CompareName(a, b)
{
	var aVal = a.cells[0].innerHTML.toLowerCase();
	var bVal = b.cells[0].innerHTML.toLowerCase();

	if (aVal > bVal) {
		return 1;
	} else if (aVal < bVal) {
		return -1;
	} else {
		return 0;
	}
}

// Sort function for the login time column
function CompareLogin(a, b)
{
	var aVal = parseInt(a.getAttribute('loginTimeInt'));
	var bVal = parseInt(b.getAttribute('loginTimeInt'));

	if (aVal > bVal) {
		return 1;
	} else if (aVal < bVal) {
		return -1;
	} else {
		return 0;
	}
}

// Sort function for the MAC address column
function CompareMAC(a, b)
{
	var aVal = a.cells[2].innerHTML;
	var bVal = b.cells[2].innerHTML;

	if (aVal > bVal) {
		return 1;
	} else if (aVal < bVal) {
		return -1;
	} else {
		return 0;
	}
}

// Sort function for the source IP address column
function CompareSrcIP(a, b)
{
	var aValArr = a.cells[3].innerHTML.split('.');
	var bValArr = b.cells[3].innerHTML.split('.');
	var aVal, bVal;

	for (var i = 0; i < aValArr.length; i++) {
		aVal = parseInt(aValArr[i]);
		bVal = parseInt(bValArr[i]);
		if (aVal > bVal) {
			return 1;
		} else if (aVal < bVal) {
			return -1;
		}
	}

	return 0;
}

// Sort function for the service column
function CompareDstPort(a, b)
{
	var aVal = a.cells[4].innerHTML;
	var bVal = b.cells[4].innerHTML;

	if (aVal > bVal) {
		return 1;
	} else if (aVal < bVal) {
		return -1;
	} else {
		return 0;
	}
}

// Sort function for the source IP address column
function CompareDstIP(a, b)
{
	var aValArr = a.cells[5].innerHTML.split('.');
	var bValArr = b.cells[5].innerHTML.split('.');
	var aVal, bVal;

	for (var i = 0; i < aValArr.length; i++) {
		aVal = parseInt(aValArr[i]);
		bVal = parseInt(bValArr[i]);
		if (aVal > bVal) {
			return 1;
		} else if (aVal < bVal) {
			return -1;
		}
	}

	return 0;
}

// Sort function for the URL column
function CompareURL(a, b)
{
	var aVal = a.cells[6].innerHTML;
	var bVal = b.cells[6].innerHTML;

	if (aVal > bVal) {
		return 1;
	} else if (aVal < bVal) {
		return -1;
	} else {
		return 0;
	}
}

// Reverse order of the table rows
function ReverseTableRow()
{
	// Obtain target table object
	var oTables = parent.frames[0].document.getElementsByTagName('TABLE');
	var oTable = oTables[0];

	if (oTable) {
		var aRow = new Array();

		// Obtain row entries
		with (oTable) {
			for (var i = 0; i < rows.length; i++) {
				aRow[i] = rows[i];
			}
		}

		// Put reverse order into DOM
		if (oTable.tBodies[0]) {
			with (oTable.tBodies[0]) {
				for (var i = aRow.length-1; i >= 0; i--) {
					appendChild(aRow[i]);
				}
			}
		}
	}
	sortReady = true;
}

// Insert extra information into specified table row
function SetExtraInfo(rowIndex, name, val)
{
	// Obtain target table object
	var oTables = parent.frames[0].document.getElementsByTagName('TABLE');
	var oTable = oTables[0];

	if (oTable) {
		with (oTable) {
			rows[rowIndex].setAttribute(name, val);
		}
	}
}

// Set black background
function UseBlackBg(tdElement)
{
	tdElement.style.background = 'url(images/tblhd_dark_c.png)';
}

// Set dark background
function UseDarkBg(tdElement)
{
	tdElement.style.background = 'url(images/tblhd_dark.png)';
}

// Set light background
function UseLightBg(tdElement)
{
	tdElement.style.background = 'url(images/tblhd_light.png)';
}

// Handle click actions in title bar
function TitleClick(targetCol)
{
	var tableObj = document.getElementsByTagName('TABLE');
	var titleObj = tableObj[1].rows[0];

	sortReady = false;
	CallURLLoadingBox(true);
	with (titleObj) {
		for (var col = 0; col < cells.length; col++) {
			if (col != targetCol) {
				cells[col].className = 'unselected';
				cells[col].setAttribute('sortStatus', '0');
				cells[col].getElementsByTagName('img')[0].style.display = 'none';
			}
		}

		cells[targetCol].className = 'selected';
		var img = cells[targetCol].getElementsByTagName('img')[0];
		img.style.display = '';
		var currSortStatus = cells[targetCol].getAttribute('sortStatus');
		if (currSortStatus == '1') {
			img.src = './images/down_tri.png';
			// Reverse sorting result
			ReverseTableRow();
			cells[targetCol].setAttribute('sortStatus', '2');
		} else {
			img.src = './images/up_tri.png';
			if (currSortStatus == '0') {
				// Do ascending sorting
				AscSortTableCol(targetCol);
			} else {
				// Reverse sorting result
				ReverseTableRow();
			}
			cells[targetCol].setAttribute('sortStatus', '1');
		}
	}

	timer = setInterval(CheckSortComplete, 100);
}

// Apply highlight effect to the row entry where the mouse is pointing
function HighlightRow(trElement, inSwitch)
{
	if (inSwitch == '0') {
		trElement.style.background = 'white';
	} else {
		trElement.style.background = '#BAEAD6';
	}
}

// Timer function to perform action if sorting is completed
function CheckSortComplete()
{
	if (sortReady) {
		sortReady = false;
		CallURLLoadingBox(false);
		clearInterval(timer);
	}
}

// 20090521 - Auto resize the frame for showing URL log
function AutoIframe(frameId)
{
	var ie = document.all;
	var ns = document.layers;
	var w3 = document.getElementById && !ie;

	frameObj = document.getElementById(frameId);
	if (ie) {
		frameHeight = document.body.offsetHeight - 70;
	} else if (ns) {
		frameHeight = window.innerHeight - 60;
	} else if (w3) {
		frameHeight = self.innerHeight - 60;
	}
	if (frameHeight <= 0) {
		frameHeight = 0;
	}
	frameObj.height = frameHeight;
}
